#!/bin/bash

declare VERSION="0.0.5b"

# History (as always in the source code :-)
#
# 0.0.3	Seems to work fine - still lacks support for X x 432 Files
#	What about MPEG Files ? 
# 0.0.4	Improved getvidxy - No Temp Files needed anymore !
#
#
#


function readcfg () {

# Aufruf:
# readcfg CFGPARM
# Searches the config file for CFGPARM and the output is the configured value !
# If not found the output is empty (test -z to determine)

if test -z $1; then echolog "*** Internal Error - Called readcfg without Option Name"; return; fi


declare -a y[0]	# Anzahl der Zeilen (idealerweise = 1 !!!)
declare -i anzahl=`grep -v -e "#" $CFGFIL | grep -i -e $1 | wc -l`
if test "$anzahl" -eq 1;
  then y=(`grep -v -e "#" $CFGFIL | grep -i -e $1`)
  anzahl=${#y[*]} # Diesmal ANZAHL der Parameter pro Zeile !
  declare -i x=0
  while x=$x+1; test $x -lt $anzahl;
    do if ! test $x -eq $(($anzahl-1)) # Noch nicht letzter Wert der Zeile ?
    	then echo -n ${y[$x]}" ";	# Diese Ausgabe wird weitergegeben !
	else echo ${y[$x]};  # Letztes Argument !
       fi
  done;
  else logger "readcfg.sh error: Option $1 found $anzahl times in $CFGFIL";
fi

return;
}

function getvidxy () {

# Aufruf: getvidxy
# Ermittelt x und y Ausloesung des FILEs ! 
# Ausgabe: in Variable ORIG_X und ORIG_Y (global)

# Variablen Definitionen
local TEMP1


ORIG_X=0; ORIG_Y=0

TEMP1=`$MPLAYER -identify "$FILE" 2>&1 | grep -i -e "^ID_VIDEO_"`
debugmsg "OutputFromMPLAYER:" "$TEMP1"

ORIG_X=`echo "$TEMP1"|grep ID_VIDEO_WIDTH|cut -d"=" -f2`
debugmsg "parsed output for ORIG_X:" $ORIG_X

ORIG_Y=`echo "$TEMP1"|grep ID_VIDEO_HEIGHT|cut -d"=" -f2`
debugmsg "parsed output for ORIG_Y:" $ORIG_Y

ORIG_FPS=`echo "$TEMP1"|grep ID_VIDEO_FPS|cut -d"=" -f2`
debugmsg "parsed output for ORIG_FPS:" $ORIG_FPS
test $ORIG_FPS == "14.985" && ORIG_FPS=29.970 && debugmsg "set ORIG_FPS to:" $ORIG_FPS
test $ORIG_FPS == "15.000" && ORIG_FPS=29.970 && debugmsg "set ORIG_FPS to:" $ORIG_FPS
test $ORIG_FPS == "30.000" && ORIG_FPS=29.970 && debugmsg "set ORIG_FPS to:" $ORIG_FPS

ORIG_ASPECT=`echo "$TEMP1"|grep ID_VIDEO_ASPECT|cut -d"=" -f2`
debugmsg "parsed output for ORIG_ASPECT:" $ORIG_ASPECT


return;
}

function calcnewxy () {

local -i TEMP1 MAX_X FACT ANZAHL

if test $ORIG_FPS == "29.970"; then
  if test $ORIG_X -gt 320 -o $ORIG_Y -gt 240; then
    # 640
    MAX_X=$((4*480/3)) ; debugvar MAX_X $MAX_X
  else
    # 320
    MAX_X=$((4*240/3)) ; debugvar MAX_X $MAX_X
  fi
  test $NEW_Y -gt 480 && NEW_Y=480 	# Force FullScreen / Verzichtet auf Aspect Ratio !
  #    NEW_X=$(($NEW_Y*$ORIG_X/$ORIG_Y));
else
  if test $ORIG_X -gt 384 -o $ORIG_Y -gt 288; then
    # 768
    MAX_X=$((4*576/3)) ; debugvar MAX_X $MAX_X
  else
    # 384
    MAX_X=$((4*288/3)) ; debugvar MAX_X $MAX_X
  fi
  test $NEW_Y -gt 576 && NEW_Y=576 	# Force FullScreen / Verzichtet auf Aspect Ratio !
  #    NEW_X=$(($NEW_Y*$ORIG_X/$ORIG_Y));
fi

NEW_Y=$(($MAX_X*ORIG_Y/$ORIG_X)); debugvar NEW_Y $NEW_Y
# NEW_X=$ORIG_X	# Hardware Skaling


echolog "*** INFO: For Sqare Pixels we would scale to $MAX_X x $NEW_Y ..."

#NEW_X=MAX_X; debugvar NEW_X $NEW_X

return;
}

function choosebestx () {

local -i MAX_X INDEX
local XResTEMP

if test $ORIG_FPS == "29.970"; then
  XResTEMP=(${XResNTSC[*]})
else
  XResTEMP=(${XResPAL[*]})
fi
debugvar XResTEMP "${XResTEMP[*]}"

ANZAHL=${#XResTEMP[*]}
debugvar AnzahlVonXResTEMP $ANZAHL

INDEX=-1
declare repeat=true
until ! $repeat;
    do INDEX=$(($INDEX+1))
    if test ${XResTEMP[$INDEX]} -ge $ORIG_X; then repeat=false; NEW_X=${XResTEMP[$INDEX]}; fi
    if test $INDEX -ge $ANZAHL; then repeat=false; NEW_X=${XResTEMP[$ANZAHL]}; fi
done

debugvar NEW_X $NEW_X

return;
}




# UNUSED

function aspectratio () {
# Direkt aus 2divx uebernommen - noch anpassen :-)

# Aufruf: aspectratio /video0/..../001.vdr
# Ausgabe: in Variable $ASPECT (global)

# Variablen Definitionen
local TEMP1
local -a TEMP2[0]
local -i ANZAHL i

ASPECT=2	# Default Value (4:3) falls nicht bestimmt werden kann !

$ENCEXE "$1" -frames 0 -o temp_weg.avi 2>$WRKTMP/temp_weg.txt >$WRKTMP/temp_weg2.txt
TEMP1=`cat $WRKTMP/temp_weg.txt $WRKTMP/temp_weg2.txt | grep -i -e "aspect"`
# Old: # TEMP1=`$ENCEXE $1 -frames 0 -o temp_weg.avi | grep -i -e "aspect"`
TEMP2=($TEMP1)
ANZAHL=${#TEMP2[*]}
i=-1

while i=i+1 ; test $i -le $((ANZAHL-1)); do
# Achtung geht davon aus, dass die Ausgabe von Mencoder lautet .. ( aspect x ) ..
    if test ${TEMP2[$i]#(} == "aspect" ; then ASPECT=${TEMP2[$((i+1))]%)}; fi
done
# ggf erzeugtes temp_weg.avi wieder entfernen !!!
if test -f $WRKTMP/temp_weg.txt; then rm $WRKTMP/temp_weg.txt; fi
if test -f $WRKTMP/temp_weg2.txt; then rm $WRKTMP/temp_weg2.txt; fi
if test -f $WRKTMP/temp_weg.avi; then rm $WRKTMP/temp_weg.avi; fi

return;
}

# UNUSED
function checkforac3 () {

# Direkt aus 2divx uebernommen - noch anpassen :-)

# Aufruf: checkforac3 /video0/.../001.vdr
# Ergebnis in $SRCAC3 (true/false)
local -i TEMP2

$ENCEXE "$1" -frames 0 -o temp_weg.avi -aid 128 2>$WRKTMP/temp_weg.txt >$WRKTMP/temp_weg2.txt
TEMP2=`cat $WRKTMP/temp_weg.txt $WRKTMP/temp_weg2.txt | grep -i -e "ac3:" | wc -l`

# Temp File lschen
if test -f $WRKTMP/temp_weg.txt; then rm $WRKTMP/temp_weg.txt; fi
if test -f $WRKTMP/temp_weg2.txt; then rm $WRKTMP/temp_weg2.txt; fi
if test -f $WRKTMP/temp_weg.avi; then rm $WRKTMP/temp_weg.avi; fi

if test $TEMP2 -gt 0; then SRCAC3=true; else SRCAC3=false; fi

return;
}

function echolog () {

# prints the String on stdout and into /var/log/messages using logger !

echo "$1"
logger "$1"
return;
}

function errorcfg () {

echolog "*** FATAL: Config Option $1 not found in Config File ... Exiting."
exit

return;
}

function debugvar () {

if $DEBUG; then echolog "*** DEBUG: Variable $1 has value \"$2\""; fi
return;
}
function debugmsg () {

if $DEBUG; then echolog "*** DEBUG: $1 \"$2\""; fi
return;
}


# Begin Main !
#
#
# ---------------------------------------------------------------------------
#
#

declare -i ORIG_X ORIG_Y
declare -i NEW_X NEW_Y
declare ORIG_FPS ORIG_ASPECT
declare CMDLINE
declare FILE=$1
SLAVE="-slave -nolirc"

if [ "$2" != "SLAVE" ]; then
  SLAVE=""
fi

echolog "*** Starting mplayer.sh Version $VERSION"

if test -z "$FILE"; then echolog "*** USAGE: mplayer.sh <File_to_be_played>"; exit; fi
if ! test -f "$FILE"; then echolog "*** ERROR: Make sure $FILE exists - otherwise it cannot be played ;-)"; exit; fi

# Check if Config File exists !
#declare CFGFIL="./mplayer.sh.conf"
declare CFGFIL="${0%mplayer.sh}mplayer.sh.conf"
debugvar CFGFIL $CFGFIL
if ! test -f $CFGFIL; then echolog "*** FATAL: mplayer.sh.conf not found !!! Exiting." ; exit; fi

# Debug Mode ?
declare DEBUG=`readcfg debug`
if test -z "$DEBUG"; then DEBUG=false; fi

# read MPLAYER Config
declare MPLAYER=`readcfg mplayer`
if test -z "$MPLAYER"; then errorcfg MPLAYER; exit; else debugvar MPLAYER "$MPLAYER"; fi

declare VOP=`readcfg vop`
if test -z "$VOP"; then errorcfg VOP; exit; else debugvar VOP "$VOP"; fi

declare CACHESTR=" " # kein cache
declare CACHE=`readcfg cache`
if ! test -z $CACHE; then CACHESTR="-cache $CACHE"; debugvar CACHE "$CACHE"; debugvar CACHESTR "$CACHESTR";
		     else echolog "*** Option CACHE not set in Config File - calling mplayer without Cache !";
fi

declare FRAMEDROP=`readcfg framedrop`
if test -z "$FRAMEDROP"; then FRAMEDROP=false; fi
debugvar FRAMEDROP "$FRAMEDROP"
declare FDSTR=" "
if $FRAMEDROP; then FDSTR="-framedrop"; fi 
debugvar FDSTR "$FDSTR"

declare LIRCSTR=" " # kein Extra Lirc Option !
declare LIRCRC=`readcfg lircrc`
if ! test -z "$LIRCRC"; then LIRCSTR="-lircconf $LIRCRC"; fi
debugvar LIRCRC "$LIRCRC"; debugvar LIRCSTR "$LIRCSTR"

declare -a USERDEF[0]
declare USERDEF=(`readcfg userdef`)
if ! test -z "$USERDEF"; then echolog "*** Use Option USERDEF at your own risk !"; fi
debugvar USERDEF "${USERDEF[*]}"

declare -a XResPAL[0]
declare XResPAL=(`readcfg XResPAL`)
if test -z $XResPAL; then errorcfg XResPAL; exit; else debugvar XResPAL "${XResPAL[*]}"; fi

declare -a XResNTSC[0]
declare XResNTSC=(`readcfg XResNTSC`)
if test -z $XResNTSC; then errorcfg XResNTSC; exit; else debugvar XResNTSC "${XResNTSC[*]}"; fi

# Try to determine the video attributes

if $DEBUG; then echolog "*** DEBUG: Calling getvidxy function to analyze source video stream ..."; fi
getvidxy


echolog "*** INFO: Source Video has Resolution of $ORIG_X x $ORIG_Y ..."

if test $ORIG_X -eq 0 -o $ORIG_Y -eq 0; then echolog "*** FATAL: Illegal Resolution ..."; exit; fi

    calcnewxy
    choosebestx
    case $ORIG_FPS in
      "23.976")
        debugmsg "Film"
      ;;
      
      "25.000")
        debugmsg "PAL"
        case $ORIG_Y in
          "288"|"576")
            CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:$ORIG_FPS,expand=-1:-1:-1:-1:1,scale=-1:-1 $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
          ;;

          *)
          ;;
        esac
      ;;
      
      "29.970")
        debugmsg "NTSC"
	if test \( $ORIG_Y -eq 240 -o $ORIG_Y -eq 480 \) -a $ORIG_X -ne 320; then
	  CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:$ORIG_FPS,expand=-1:-1:-1:-1:1,scale=-1:-1 $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
        else
          if test $ORIG_X > 352 -o $ORIG_Y > 240; then
            debugmsg "ORIG_Y greater than 240:" $ORIG_Y
            CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:$ORIG_FPS,expand=$NEW_X:480:-1:-1:1,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
          else
            debugmsg "ORIG_Y less than or equal to 240:" $ORIG_Y
            CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:$ORIG_FPS,expand=$NEW_X:240:-1:-1:1,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
          fi
        fi
      ;;

      *)
        debugmsg "unknown FPS" $ORIG_FPS
      ;;
    esac
    if test $NEW_X -eq 0 -o $NEW_Y -eq 0; then echolog "*** FATAL: Illegal Resolution ..."; exit; fi
    if test -z $CMDLINE; then 
      if test $ORIG_X -gt 384 -o $ORIG_Y -gt 288; then
	debugmsg "ORIG_Y greater than 288:" $ORIG_Y
        CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:25,expand=$NEW_X:576:-1:-1:1,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
      else
	debugmsg "ORIG_Y less than or equal to 288:" $ORIG_Y
        CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:25,expand=$NEW_X:288:-1:-1:1,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
      fi
      echolog "*** Scaling to $NEW_X x $NEW_Y for DVBs Output..."
    fi
#    CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1:$ORIG_FPS,expand=$NEW_X:576:-1:-1:1,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
    #CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP=-1,$ORIG_FPS,expand=$NEW_X:576,scale=$NEW_X:$NEW_Y $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
#    CMDLINE="$MPLAYER -vo mpegpes -ao mpegpes -afm 9 -vop $VOP,scale=$NEW_X:$NEW_Y,expand=$NEW_X:576 $FDSTR $CACHESTR $LIRCSTR $USERDEF $SLAVE"
    debugvar CMDLINE "$CMDLINE"
    exec $CMDLINE "$FILE" -
    echo "*** Done.";

  



exit

# Simple way :-)
# exec /usr/local/bin/mplayer -vo mpegpes -ao mpegpes $1 -framedrop -lircconf /video0/.lircrc < /dev/zero
# ??? declare MPLAYER="exec /usr/local/bin/mplayer"
declare OPTS="-vo mpegpes -ao mpegpes -vop lavc,scale=704:576 -afm 9 -cache 4096 -framedrop -lircconf /video0/.lircrc"
# declare OPTS="-vo mpegpes -ao mpegpes -vop lavc -afm 9 -cache 4096 -framedrop -lircconf /video0/.lircrc"

declare FILE=$1
declare type=`file "$FILE"`

case "$type" in
    *AVI*)
     declare VC="-vc odivx"
     ;;
    *MPEG*)
     declare VC="-vc mpegpes"
     ;;
    *)
     declare VC="-vc mpegpes"
     echo "Assuming MPEGPES Format !!!!"
     echo "Edit /video0/mplayer.sh to support this format !"
     ;;
esac

echo Executing "$MPLAYER $OPTS $VC "$FILE" -"
$MPLAYER $OPTS $VC "$FILE" -


